#include <stdio.h>
#include <stdlib.h>
#include <getopt.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/socket.h>
#include <netinet/in.h>

const static struct option longopts[] = {
	{ "destination-file", required_argument, NULL, 'd' },
	{ NULL, 0, NULL, 0 }
};

void read_destination_list(char *filename)
{
	
}

void parse_options(int argc, char **argv)
{
	int option_index = 0;

	for ( ;; ) {
		int c = getopt_long(argc, argv, "d:", longopts, &option_index); 
		switch (c) {
		case 'd':
			read_destination_list(optarg);
			break;
		case -1:
			return;       // end of argument list
		default:
			fprintf(stderr, "Invalid option\n");
			exit(1);
		}
	}
}

void *receiver_worker(void *arg)
{
	int sock = (int)arg;
	char buf[65536];

	printf("Received worker for socket %u\n", sock);

	for ( ;; ) {
		int ret = read(sock, buf, 65536);
		if (ret == 0)
			break;

		// FIXME: update stats here
	}

	printf("Socket %u done\n", sock);
	
	if (close(sock) == -1) {
		perror("close()");
		exit(1);
	}

	pthread_exit(0);
}

int get_server_socket(unsigned short port)
{
	int server_sock;
	struct sockaddr_in sin;
	unsigned one = 1;

	server_sock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
	if (server_sock == -1) {
		perror("socket()");
		exit(1);
	}

	if (setsockopt(server_sock, SOL_SOCKET, SO_REUSEADDR, &one, sizeof(one)) == -1) {
		perror("setsocket(SO_REUSEADDR)");
		exit(1);
	}

	sin.sin_family = AF_INET;
	sin.sin_port = htons(port);
	sin.sin_addr.s_addr = INADDR_ANY;

	if (bind(server_sock, (struct sockaddr *)&sin, sizeof(struct sockaddr)) == -1) {
		perror("bind()");
		exit(1);
	}

	if (listen(server_sock, 255) == -1) {
		perror("listen()");
		exit(1);
	}

	return server_sock;
}

int main(int argc, char **argv)
{
	int server_sock;

	parse_options(argc, argv);
	server_sock = get_server_socket(2007);

	// FIXME: fire off sender workers here

	/*
	 * Listen for incoming connections, spawning off one receiver
	 * thread for each (which will just gobble up the data until
	 * we're done).
	 */
	for ( ;; ) {
		struct sockaddr_in addr;
		socklen_t addr_len = sizeof(addr);
		pthread_t thread;
		pthread_attr_t attr;

		int sock = accept(server_sock, (struct sockaddr *)&addr, &addr_len);
		if (sock == -1) {
			perror("accept()");
			exit(1);
		}

		// FIXME: these do not really set errno
		if (pthread_attr_init(&attr) != 0) {
			perror("pthread_attr_init()");
			exit(1);
		}

		if (pthread_attr_setstacksize(&attr, PTHREAD_STACK_MIN + 65536 + 0x4000) != 0) {
			perror("pthread_attr_setstacksize");
			exit(1);
		}

		if (pthread_create(&thread, &attr, receiver_worker, (void *)sock) != 0) {
			perror("pthread_create()");
			exit(1);
		}
	}

	exit(0);
}
